
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>用ajax来控制书签和回退按钮 / iVAN</title>

    <meta name="description" content="用ajax来控制书签和回退按钮 ajax|按钮|控制|书签 这篇文章描述了一个支持ajax应用书签和回退按钮的开源的javascript库.在这个指南的最后,开发者将会得出一个甚至不是google maps 或者 gmail那样处理的ajax的解决方案:健壮的,可用的书签和向前向后的动作能够象其他的web页面一样正确的工作. ajax:怎样去控制书签和回退按钮 这篇文章说明了一个重要的成果,ajax应用目前面对着书签和回退按钮的应用,描述了非常简单的历史库(really simple history),一个开源的解决这类问题的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">用ajax来控制书签和回退按钮</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>ajax|按钮|控制|书签</p>
<p>这篇文章描述了一个支持ajax应用书签和回退按钮的开源的javascript库。在这个指南的最后，开发者将会得出一个甚至不是google maps 或者 gmail那样处理的ajax的解决方案：健壮的，可用的书签和向前向后的动作能够象其他的web页面一样正确的工作。</p>
<p><u>ajax：怎样去控制书签和回退按钮</u> 这篇文章说明了一个重要的成果，ajax应用目前面对着书签和回退按钮的应用，描述了非常简单的历史库（really simple history），一个开源的解决这类问题的框架，并提供了一些能够运行的例子。</p>
<p>这篇文章描述的主要问题是双重的，一是一个隐藏的html 表单被用作一个大而短生命周期的客户端信息的session缓存，这个缓存对在这个页面上前进回退是强壮的。二是一个锚连接和隐藏的iframes的组合用来截取和记录浏览器的历史事件，来实现前进和回退的按钮。这两个技术都被用一个简单的javascript库来封装，以利于开发者的使用。</p>
<p><strong>存在的问题</strong><br />书签和回退按钮在传统的多页面的web应用上能顺利的运行。当用户在网站上冲浪时，他们的浏览器地址栏能更新url,这些url可以被粘贴到的email或者添加到书签以备以后的使用。回退和前进按钮也可以正常运行，这可以使用户在他们访问的页面间移动。</p>
<p>ajax应用是与众不同的，然而，他也是在单一web页面上成熟的程序。浏览器不是为ajax而做的—ajax他捕获过去的事件，当web应用在每个鼠标点击时刷新页面。</p>
<p>在象gmail那样的ajax软件里，浏览器的地址栏正确的停留就象用户在选择和改变应用的状态时，这使得作书签到特定的应用视图里变得不可能。此外，如果用户按下了他们的回退按钮去返回上一个操作，他们会惊奇的发现浏览器将完全离开原来他所在的应用的web页面。</p>
<p><strong>解决方案</strong><br />开源的really simply history(rsh)框架解决了这些问题，他带来了ajax应用的作书签和控制前进后退按钮的功能。rsh目前还是beta版，在firefox1.0上.netscape7及以上,和ie6及以上运行。safari现在还不支持（要得到更详细的说明，请看我的weblog中的文章coding in paradise: safari: no dhtml history possible).</p>
<p>目前存在的几个ajax框架可以帮助我们做书签和发布历史，然而所有的框架都因为他们的实现而被几个重要的bug困扰（请看coding in paradise: ajax history libraries 得知详情）。此外，许多ajax历史框架集成绑定到较大的库上，比如backbase 和 dojo，这些框架提供了与传统ajax应用不同的编程模型，强迫开发者去采用一整套全新的方式去获得浏览器的历史相关的功能。</p>
<p>相应的，rsh是一个简单的模型，能被包含在已经存在的ajax系统中。而且，really simple history库使用了一些技巧去避免影响到其他历史框架的bug.</p>
<p>really simple history框架由2个javascript类库组成，分别叫dhtmlhistory 和 historystorage.</p>
<p>dhtmlhistory 类提供了一个对ajax应用提取历史的功能。.ajax页面add() 历史事件到浏览器里，指定新的地址和关联历史数据。dhtmlhistory 类用一个锚的hash表更新浏览器现在的url，比如#new-location ，然后用这个新的url关联历史数据。ajax应用注册他们自己到历史监听器里，然后当用户用前进和后退按钮导航的时候，历史事件被激发，提供给浏览器新的地址和调用add()持续保留数据。</p>
<p>第二个类historystorage，允许开发者存储任意大小的历史数据。一般的页面，当一个用户导航到一个新的网站，浏览器会卸载和清除所有这个页面的应用和javascript状态信息。如果用户用回退按钮返回过来了，所有的数据已经丢失了。historystorage 类解决了这个问题，他有一个api 包含简单的hashtable方法比如put(),get(),haskey()。这些方法允许开发者在离开web页面时存储任意大小的数据，当用户点了回退按钮返回时，数据可以通过historystorage 类被访问。我们通过一个隐藏的表单域（a hidden form field），利用浏览器即使在用户离开web页面也会自动保存表单域值的这个特性，完成这个功能。</p>
<p>让我们立即进入一个简单的例子吧。</p>
<p><strong>示例1</strong><br />首先，任何一个想使用really simple history框架的页面必须包含（include）dhtmlhistory.js 脚本。</p>
<pre>&lt;!-- load the really simple      history framework --&gt;&lt;script type="text/javascript"        src="../../framework/dhtmlhistory.js"&gt;&lt;/script&gt;</pre>
<p>dhtml history 应用也必须在和ajax web页面相同的目录下包含一个叫blank.html 的指定文件，这个文件被really simple history框架绑定而且对ie来说是必需的。另一方面，rsh使用一个hidden iframe 来追踪和加入ie历史的改变，为了正确的执行功能，这个iframe需要指向一个真正的地址，不需要blank.html。</p>
<p>rsh框架创建了一个叫dhtmlhistory 的全局对象，作为操作浏览器历史的入口。使用dhtmlhistory 的第一步需要在页面加载后初始化这个对象。</p>
<pre>window.onload = initialize;    function initialize() {  // initialize the dhtml history  // framework  dhtmlhistory.initialize();</pre>
<p>然后，开发者使用dhtmlhistory.addlistener()方法去订阅历史改变事件。这个方法获取一个javascript回调方法，当一个dhtml历史改变事件发生时他将收到2个自变量，新的页面地址，和任何可选的而且可以被关联到这个事件的历史数据。</p>
<pre>indow.onload = initialize;    function initialize() {  // initialize the dhtml history  // framework  dhtmlhistory.initialize();    // subscribe to dhtml history change  // events  dhtmlhistory.addlistener(historychange);</pre>
<p>historychange()方法是简单易懂得，它是由一个用户导航到一个新地址后收到的新地址（newlocation）和一个关联到事件的可选的历史数据historydata 构成的。</p>
<pre>/** our callback to receive history change     events. */function historychange(newlocation,                        historydata) {  debug("a history change has occurred: "        + "newlocation="+newlocation        + ", historydata="+historydata,         true);}</pre>
<p>上面用到的debug()方法是例子代码中定义的一个工具函数，在完整的下载例子里有。debug()方法简单的在web页面上打一条消息，第2个boolean变量，在代码里是true,控制一个新的debug消息打印前是否要清除以前存在的所有消息。</p>
<p>一个开发者使用add()方法加入历史事件。加入一个历史事件包括根据历史的改变指定一个新的地址，就像"edit:somepage"标记, 还提供一个事件发生时可选的会被存储到历史数据historydata值.</p>
<pre>window.onload = initialize;    function initialize() {  // initialize the dhtml history  // framework  dhtmlhistory.initialize();    // subscribe to dhtml history change  // events  dhtmlhistory.addlistener(historychange);        // if this is the first time we have  // loaded the page...  if (dhtmlhistory.isfirstload()) {    debug("adding values to browser "          + "history", false);    // start adding history    dhtmlhistory.add("helloworld",                      "hello world data");    dhtmlhistory.add("foobar", 33);    dhtmlhistory.add("boobah", true);          var complexobject = new object();    complexobject.value1 =                   "this is the first value";    complexobject.value2 =                   "this is the second data";    complexobject.value3 = new array();    complexobject.value3[0] = "array 1";    complexobject.value3[1] = "array 2";          dhtmlhistory.add("complexobject",                      complexobject);</pre>
<p>在add()方法被调用后，新地址立刻被作为一个锚值显示在用户的浏览器的url栏里。例如，一个ajax web页面停留在http://codinginparadise.org/my_ajax_app，调用了dhtmlhistory.add("helloworld", "hello world data" 后，用户将在浏览器的url栏里看到下面的地址<br />http://codinginparadise.org/my_ajax_app#helloworld</p>
<p>然后他们可以把这个页面做成书签，如果他们使用这个书签，你的ajax应用可以读出#helloworld值然后使用她去初始化web页面。hash里的地址值被really simple history  框架显式的编码和解码（url encoded and decoded） （这是为了解决字符的编码问题）</p>
<p>对当ajax地址改变时保存更多的复杂的状态来说，historydata  比一个更容易的匹配一个url的东西更有用。他是一个可选的值，可以是任何javascript类型，比如number, string, 或者 object 类型。有一个例子是用这个在一个多文本编辑器（rich text editor）保存所有的文本，例如，如果用户从这个页面漂移（或者说从这个页面导航到其他页面，离开了这个页面）走。当一个用户再回到这个地址，浏览器会把这个对象返回给历史改变侦听器（history change listener）。</p>
<p>开发者可以提供一个完全的historydata 的javascript对象，用嵌套的对象objects和排列arrays来描绘复杂的状态。只要是json (javascript object notation)  允许的那么在历史数据里就是允许的，包括简单数据类型和null型。dom的对象和可编程的浏览器对象比如xmlhttprequest ，不会被保存。注意historydata 不会被书签持久化，如果浏览器关掉，或者浏览器的缓存被清空，或者用户清除历史的时候，会消失掉。</p>
<p>使用dhtmlhistory 最后一步，是isfirstload() 方法。如果你导航到一个web页面，再跳到一个不同的页面，然后按下回退按钮返回起始的网站，第一页将完全重新装载，并激发onload事件。这样能产生破坏性，当代码在第一次装载时想要用某种方式初始化页面的时候，不会再刷新页面。isfirstload() 方法让区别是最开始第一次装载页面，还是相对的，在用户导航回到他自己的浏览器历史中记录的网页时激发load事件，成为可能。</p>
<p>在例子代码中，我们只想在第一次页面装载的时候加入历史事件，如果用户在第一次装载后，按回退按钮返回页面，我们就不想重新加入任何历史事件。</p>
<pre>window.onload = initialize;    function initialize() {  // initialize the dhtml history  // framework  dhtmlhistory.initialize();    // subscribe to dhtml history change  // events  dhtmlhistory.addlistener(historychange);        // if this is the first time we have  // loaded the page...  if (dhtmlhistory.isfirstload()) {    debug("adding values to browser "          + "history", false);    // start adding history    dhtmlhistory.add("helloworld",                      "hello world data");    dhtmlhistory.add("foobar", 33);    dhtmlhistory.add("boobah", true);          var complexobject = new object();    complexobject.value1 =                   "this is the first value";    complexobject.value2 =                   "this is the second data";    complexobject.value3 = new array();    complexobject.value3[0] = "array 1";    complexobject.value3[1] = "array 2";          dhtmlhistory.add("complexobject",                      complexobject);</pre>
<p>让我们继续使用historystorage 类。类似dhtmlhistory ，historystorage通过一个叫historystorage的单一全局对象来显示他的功能，这个对象有几个方法来伪装成一个hash table, 象put(keyname, keyvalue), get(keyname), and haskey(keyname).键名必须是字符，同时键值可以是复杂的javascript对象或者甚至是xml格式的字符。在我们源码source code的例子中，我们put() 简单的xml  到historystorage 在页面第一次装载时。</p>
<pre>window.onload = initialize;    function initialize() {  // initialize the dhtml history  // framework  dhtmlhistory.initialize();    // subscribe to dhtml history change  // events  dhtmlhistory.addlistener(historychange);        // if this is the first time we have  // loaded the page...  if (dhtmlhistory.isfirstload()) {    debug("adding values to browser "          + "history", false);    // start adding history    dhtmlhistory.add("helloworld",                      "hello world data");    dhtmlhistory.add("foobar", 33);    dhtmlhistory.add("boobah", true);          var complexobject = new object();    complexobject.value1 =                   "this is the first value";    complexobject.value2 =                   "this is the second data";    complexobject.value3 = new array();    complexobject.value3[0] = "array 1";    complexobject.value3[1] = "array 2";          dhtmlhistory.add("complexobject",                      complexobject);                         // cache some values in the history    // storage    debug("storing key 'fakexml' into "           + "history storage", false);    var fakexml =       '&lt;?xml version="1.0" '      +      'encoding="iso-8859-1"?&gt;'      +      '&lt;foobar&gt;'      +         '&lt;foo-entry/&gt;'      +      '&lt;/foobar&gt;';    historystorage.put("fakexml", fakexml);  } </pre>
<p>然后，如果用户从这个页面漂移走（导航走）又通过返回按钮返回了，我们可以用get（）提出我们存储的值或者用haskey（）检查他是否存在。</p>
<pre>window.onload = initialize;    function initialize() {  // initialize the dhtml history  // framework  dhtmlhistory.initialize();    // subscribe to dhtml history change  // events  dhtmlhistory.addlistener(historychange);        // if this is the first time we have  // loaded the page...  if (dhtmlhistory.isfirstload()) {    debug("adding values to browser "          + "history", false);    // start adding history    dhtmlhistory.add("helloworld",                      "hello world data");    dhtmlhistory.add("foobar", 33);    dhtmlhistory.add("boobah", true);          var complexobject = new object();    complexobject.value1 =                   "this is the first value";    complexobject.value2 =                   "this is the second data";    complexobject.value3 = new array();    complexobject.value3[0] = "array 1";    complexobject.value3[1] = "array 2";          dhtmlhistory.add("complexobject",                      complexobject);                         // cache some values in the history    // storage    debug("storing key 'fakexml' into "           + "history storage", false);    var fakexml =       '&lt;?xml version="1.0" '      +      'encoding="iso-8859-1"?&gt;'      +      '&lt;foobar&gt;'      +         '&lt;foo-entry/&gt;'      +      '&lt;/foobar&gt;';    historystorage.put("fakexml", fakexml);  }     // retrieve our values from the history  // storage  var savedxml =               historystorage.get("fakexml");  savedxml = prettyprintxml(savedxml);  var haskey =            historystorage.haskey("fakexml");  var message =    "historystorage.haskey('fakexml')="    + haskey + "&lt;br&gt;"    + "historystorage.get('fakexml')=&lt;br&gt;"    + savedxml;  debug(message, false);}</pre>
<p>prettyprintxml() 是一个第一在例子源码full example source code中的工具方法。这个方法准备简单的xml显示在web page ，方便调试。</p>
<p>注意数据只是在使用页面的历史时被持久化，如果浏览器关闭了，或者用户打开一个新的窗口又再次键入了ajax应用的地址，历史数据对这些新的web页面是不可用的。历史数据只有在用前进或回退按钮时才被持久化，而且在用户关闭浏览器或清空缓存的时候会消失掉。想真正的长时间的持久化，请看ajax massive storage system (amass).<br />我们的简单示例已经完成。演示他（demo it）或者下载全部的源代码（download the full source code.）</p>
<p><strong>示例2</strong><br />我们的第2个例子是一个简单的模拟ajax email  应用的示例，叫o'reilly mail,类似gmail. o'reilly mail描述了怎样使用dhtmlhistory类去控制浏览器的历史，和怎样使用historystorage对象去缓存历史数据。</p>
<p>o'reilly mail 用户接口（user interface）有两部分。在页面的左边是一个有不同email文件夹和选项的菜单，例如 收件箱，草稿，等等。当一个用户选择了一个菜单项，比如收件箱，我们用这个菜单项的内容更新右边的页面。在一个实际应用中，我们会远程取得和显示选择的信箱内容，不过在o'reilly mail里，我们简单的显示选择的选项。</p>
<p>o'reilly mail使用really simple history 框架向浏览器历史里加入菜单变化和更新地址栏，允许用户利用浏览器的回退和前进按钮对应用做书签和跳到上一个变化的菜单。</p>
<p>我们加入一个特别的菜单项，地址簿，来描绘historystorage 能够怎样被使用。地址簿是一个由联系的名字电子邮件和地址组成的javascript数组，在一个真实的应用里我们会取得他从一个远程的服务器。不过，在o'reilly mail里，我们在本地创建这个数组，加入几个名字电子邮件和地址，然后把他们存储在historystorage 对象里。如果用户离开了这个web页面以后又返回的话，o'reilly mail应用重新从缓存里得到地址簿，胜过（不得不）再次访问远程服务器。</p>
<p>地址簿是在我们的初始化initialize()方法里存储和重新取得的</p>
<pre>/** our function that initializes when the page    is finished loading. */function initialize() {   // initialize the dhtml history framework   dhtmlhistory.initialize();      // add ourselves as a dhtml history listener   dhtmlhistory.addlistener(handlehistorychange);

   // if we haven't retrieved the address book   // yet, grab it and then cache it into our   // history storage   if (window.addressbook == undefined) {      // store the address book as a global      // object.      // in a real application we would remotely      // fetch this from a server in the      // background.      window.addressbook =         ["brad neuberg 'bkn3@columbia.edu'",          "john doe 'johndoe@example.com'",          "deanna neuberg 'mom@mom.com'"];                // cache the address book so it exists      // even if the user leaves the page and      // then returns with the back button      historystorage.put("addressbook",                         addressbook);   }   else {      // fetch the cached address book from      // the history storage      window.addressbook =                historystorage.get("addressbook");   }</pre>
<p>处理历史变化的代码是简单的。在下面的代码中，当用户不论按下回退还是前进按钮handlehistorychange 都被调用。我们得到新的地址（newlocation） 使用他更新我们的用户接口来改变状态，通过使用一个叫displaylocation的o'reilly mail的工具方法。</p>
<pre>/** handles history change events. */function handlehistorychange(newlocation,                              historydata) {   // if there is no location then display   // the default, which is the inbox   if (newlocation == "") {      newlocation = "section:inbox";   }      // extract the section to display from   // the location change; newlocation will   // begin with the word "section:"    newlocation =          newlocation.replace(/section\:/, "");      // update the browser to respond to this   // dhtml history change   displaylocation(newlocation, historydata);}

/** displays the given location in the     right-hand side content area. */function displaylocation(newlocation,                         sectiondata) {   // get the menu element that was selected   var selectedelement =             document.getelementbyid(newlocation);               // clear out the old selected menu item   var menu = document.getelementbyid("menu");   for (var i = 0; i &lt; menu.childnodes.length;                                          i++) {      var currentelement = menu.childnodes[i];      // see if this is a dom element node      if (currentelement.nodetype == 1) {         // clear any class name         currentelement.classname = "";      }                                          }       // cause the new selected menu item to   // appear differently in the ui   selectedelement.classname = "selected";      // display the new section in the right-hand   // side of the screen; determine what    // our sectiondata is      // display the address book differently by   // using our local address data we cached   // earlier   if (newlocation == "addressbook") {      // format and display the address book      sectiondata = "&lt;p&gt;your addressbook:&lt;/p&gt;";      sectiondata += "&lt;ul&gt;";            // fetch the address book from the cache      // if we don't have it yet      if (window.addressbook == undefined) {         window.addressbook =                historystorage.get("addressbook");      }            // format the address book for display      for (var i = 0;                i &lt; window.addressbook.length;                     i++) {         sectiondata += "&lt;li&gt;"                        + window.addressbook[i]                        + "&lt;/li&gt;";                        }            sectiondata += "&lt;/ul&gt;";   }      // if there is no sectiondata, then    // remotely retrieve it; in this example   // we use fake data for everything but the   // address book   if (sectiondata == null) {      // in a real application we would remotely      // fetch this section's content      sectiondata = "&lt;p&gt;this is section: "          + selectedelement.innerhtml + "&lt;/p&gt;";     }      // update the content's title and main text   var contenttitle =          document.getelementbyid("content-title");   var contentvalue =         document.getelementbyid("content-value");   contenttitle.innerhtml =                         selectedelement.innerhtml;   contentvalue.innerhtml = sectiondata;}</pre>
<p>演示（demo）o'reilly mail或者下载（download）o'reilly mail的源代码。</p>
<p><strong>结束语</strong><br />你现在已经学习了使用really simple history api 让你的ajax应用响应书签和前进回退按钮，而且有代码可以作为创建你自己的应用的素材。我热切地期待你利用书签和历史的支持完成你的ajax创造。</p>
<p>资源<br />·onjava.com:onjava.com<br />·matrix-java开发者社区:http://www.matrix.org.cn/<br />·download all sample code for this article. <br />·download the really simple history framework. <br />·demo o'reilly mail or download the o'reilly mail source code. the full example download also includes more examples for you to play with. <br />·coding in paradise: the author's weblog, covering ajax, dhtml, and java techniques and new developments in collaborative technologies, such as wikiwikis.</p>
<p><strong>感谢</strong><br />特别的要感谢每个检阅这篇文章的the really simple history框架的人：<br />michael eakes, jeremy sevareid, david barrett, brendon wilson, dylan parker, erik arvidsson, alex russell, adam fisk, alex lynch, joseph hoang do, richard macmanus, garret wilson, ray baxter, chris messina, and david weekly.<br /> </p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索浏览器<br />
                    ，                页面<br />
                    ，                initialize<br />
                    ，                一个<br />
                    ，                The<br />
                                    history<br />
                                    chrome书签按钮、点击按钮触发ajax请求、点击按钮发送ajax请求、ajax点击按钮触发事件、ajax按钮点击事件，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 11:28:34</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8f%e8%a7%88%e5%99%a8/" title="浏览器">浏览器</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e9%a1%b5%e9%9d%a2/" title="页面">页面</a>, <a href="https://www.iamivan.net/tag/the/" title="The">The</a>, <a href="https://www.iamivan.net/tag/history/" title="history">history</a>, <a href="https://www.iamivan.net/tag/initialize/" title="initialize">initialize</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>用ajax来控制书签和回退按钮的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyyq8M.html" rel="bookmark">用 AJAX 来控制书签和回退按钮</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax|按钮|控制|书签 这篇文章描述了一个支持AJAX应用书签和回退按钮的开源的javascript库.在这个指南的最后,开发者将会得出一个甚至不是Google Maps 或者 Gmail那样处理的AJAX的解决方案:健壮的,可用的书签和向前向后的动作能够象其他的web页面一样正确的工作. AJAX:怎样去控制书签和回退按钮 这篇文章说明了一个重要的成果,AJAX应用目前面对着书签和回退按钮的应用,描述了非常简单的历史库(Really Simple History),一个开源的解决这类问题的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEY4n6b.html" rel="bookmark">用Ajax来控制书签和回退按钮的代码&lowbar;AJAX相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章描述了一个支持Ajax应用书签和回退按钮的开源的javascript库.在这个指南的最后,开发者将会得出一个甚至不是Google Maps 或者 Gmail那样处理的Ajax的解决方案:健壮的,可用的书签和向前向后的动作能够象其他的web页面一样正确的工作. Ajax:怎样去控制书签和回退按钮 这篇文章说明了一个重要的成果,Ajax应用目前面对着书签和回退按钮的应用,描述了非常简单的历史库(Really Simple History),一个开源的解决这类问题的框架,并提供了一些能够运行的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxlJeGM.html" rel="bookmark">用Ajax来控制书签和回退按钮的代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章描述了一个支持Ajax应用书签和回退按钮的开源的javascript库.在这个指南的最后,开发者将会得出一个甚至不是Google Maps 或者 Gmail那样处理的Ajax的解决方案:健壮的,可用的书签和向前向后的动作能够象其他的web页面一样正确的工作. Ajax:怎样去控制书签和回退按钮 这篇文章说明了一个重要的成果,Ajax应用目前面对着书签和回退按钮的应用,描述了非常简单的历史库(Really Simple History),一个开源的解决这类问题的框架,并提供了一些能够运行的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgWlOM.html" rel="bookmark">AJAX：如何处理书签和后退按钮</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax|按钮|书签 本文将展示一个开源JavaScript库,该脚本库给AJAX应用程序带来了书签和后退按钮支持.在学习完这个教程后,开发人员将能够获得对一个AJAX问题的解决方案(甚至连Google Maps和Gmail现在都不提供该解决方案):一个强大的.可用的书签和后退前进功能,其操作行为如同其他的Web应用程序一样. 简单示例下载完整源代码.示例二下载O'Reilly Mail源代码. 本文将阐述目前AJAX应用程序在使用书签和后退按钮方面所面临的严重问题:展示Really Simpl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YbK3nZb.html" rel="bookmark">如何使用Ajax解决书签和后退按钮失效问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文将展示一个开源JavaScript库,该脚本库给AJAX应用程序带来了书签和后退按钮支持.在学习完这个教程后,开发人员将能够获得对一个AJAX问题的解决方案(甚至连Google Maps和Gmail现在都不提供该解决方案):一个强大的.可用的书签和后退前进功能,其操作行为如同其他的Web应用程序一样. 本文将阐述目前AJAX应用程序在使用书签和后退按钮方面所面临的严重问题:展示Really Simple History(RSH)库--一个可以解决以上问题的开源框架,并提供几个运行中的例子.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkeG6db.html" rel="bookmark">javascript-怎样控制浏览器左上后退按钮事件&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 怎样控制浏览器左上后退按钮事件? 页面描述:初始进入是一个a.jsp,动态控制某条件下页面会刷新为b.jsp 目的:控制页面,禁止后退? 处理:禁用了页面右键(快捷键等),设置页面是弹窗_blank(无工具栏,无后退.前进按钮): 问题:用户浏览器可以设置总在新页签打开,这时候页签在浏览器内,左上角后退按钮无法控制住禁用: 求教大虾 ~有没有好的解决方法(支持ie/firefox/google) 解决方案 用location.replace('http://www.w3dev.cn')			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmK4kDb.html" rel="bookmark">sendmessage-c&num; 通过句柄控制另外一个程序按钮，作用无效</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 c# 通过句柄控制另外一个程序按钮,作用无效 我用一个c# 程序 通过spy++ 获取到另外一个程序的 按钮句柄 进行点击操作无效(测试的软件已经正常打开了): 我用此方法测试了 电脑自带的 计算器程序可以正常使用 代码如下 IntPtr okbtn = new IntPtr(0x0A0970); //spy++ 获取到的按钮句柄 const uint BM_CLICK = 0xF5; System.Threading.Thread.Sleep(1000); SendMessage(o			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOW21mz.html" rel="bookmark">qt-Qt如何实现按钮控制文本框显示按钮上的字符</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Qt如何实现按钮控制文本框显示按钮上的字符 我刚接触Qt,用Qt来写一个计算器,如何实现使PushBut上的数字在LineEdit上显示 解决方案 假设 QPushBut number : QLineEdit result: 在按钮的槽函数下设置 result-&gt;setText(&quot;9&quot;):			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX9aqQz.html" rel="bookmark">《jQuery、jQuery UI及jQuery Mobile技巧与示例》&mdash;&mdash;9&period;10　技巧：生成回退按钮</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				9.10 技巧:生成回退按钮 当用户在页面间浏览时,有时候他会想返回到之前的页面.很明显Web浏览器为此提供了标准的回退按钮. 所以,有很好的理由在你的Web应用程序中也提供回退按钮.一个理由是当你的Web应用程序在全屏运行时,浏览器的回退按钮可能无法使用.更重要的是,jQuery Mobile应用程序模拟了原生应用程序的外观.在原生的应用程序中,回退按钮被放置在屏幕的左上角. 代码清单9-11演示了jQuery Mobile是如何使&quot;在需要时添加回退按钮&quot;变得非常简单的. 代码清单9			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp80yop.html" rel="bookmark" class="title">CSS巧用expression来区分只读文本框</a>
					<div>
						css|express|文本框     对于文本框,只读状态下和普通状态下,浏览器对其并没有做什么特殊的标记,表面看来,效果是一样的,这样,对用户来说,易用性并不是很高.     当然,我们可以改变只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3adJp.html" rel="bookmark" class="title">Spring Framework 1&period;2 RC1 发布</a>
					<div>
						增加了一些对jdk50的支持,Hibernate3支持,还有JMX支持,不知道他的JMX支持如何.ANNOUNCEMENT: Dear Spring community,  It's Spring t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqoK3z.html" rel="bookmark" class="title">谈谈JavaScript中的数组、集合及效率</a>
					<div>
						javascript|集合|数组 数组是JavaScript提供的一个内部对象,它是一个标准的集合,我们可以添加(push).删除(shift)里面元素,我们还可以通过for循环遍历里面的元素,那么除 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm0o5M.html" rel="bookmark" class="title">LigerUi中Grid的是否显示工具条&lpar;toolbar&rpar;！（动态的）</a>
					<div>
						// ================== cs代码 protected void Page_Load(object sender, EventArgs e) { } protected string ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaAA3M.html" rel="bookmark" class="title">识别和防御Web网页木马的几种方法</a>
					<div>
						根据反病毒厂商Sophos今年的第一.第二季度报告,网页已经超过电子邮件成为恶意软件传播时最喜欢使用的途径,通过网页传播的恶意软件平均每月增加300多种.而对用户来说,因为用户自己在互联网浏览时的安全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElg8qz.html" rel="bookmark" class="title">神经网络：感知机和线性神经网络的实现</a>
					<div>
						友情提示:本文系参考机械工业出版社&lt;神经网络设计&gt;(戴葵等译)一书而编制的相关程序,对于初学者或者想深入了解神经网络内核的爱好者,这是一本最具有阅读价值的教材. 感知机和线性神经网络是最简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOLNOb.html" rel="bookmark" class="title">Photoshop制作金色古纹理浮雕字</a>
					<div>
						效果图实际制作过程是非常复杂的,包括了前期的字体设计.纹理渲染.背景及装饰部分制作等.这里只精选中间文字效果制作过程,字体直接有分层图提供. photoshop教程最终效果 1.点这里下载文字PSD素 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPAkOz.html" rel="bookmark" class="title">超实用的PS ACR修图冷知识</a>
					<div>
						  我们打开PS的预设文件夹,就会发现这里不仅有全局调整如&quot;颜色查找&quot;等的预设,还有很多其他各类型的预设如笔刷.动作.样式等等;那我们再打开ACR的安装文件夹,虽然它并不像PS有明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oKeWb.html" rel="bookmark" class="title">时间复杂度分别为 O（n）和 O（1）的删除单链表结点的方法</a>
					<div>
						有一个单链表,提供了头指针和一个结点指针,设计一个函数,在 O(1)时间内删除该结点指针指向的结点. 众所周知,链表无法随机存储,只能从头到尾去遍历整个链表,遇到目标节点之后删除之,这是最常规的思路和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3nklz.html" rel="bookmark" class="title">EA强大的画图工具---设计数据库表格</a>
					<div>
						         关于EA这个优秀的软件是从师哥哪里听来的,自己瞎点了点,感觉也没什么.最近和和智福加上一个师哥合作敲机房收费系统时,想到之前听人说EA很强大,便随便找了找关于EA使用的帮助手册.果然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l6qxb.html" rel="bookmark" class="title">CYQ&period;Data 数据框架 V3&period;5 开源版本发布&lpar;源码提供下载&rpar;</a>
					<div>
						 先说几句:    最近一直在忙微博粉丝精灵+微博人气精灵的微博精灵系列软件的事,简单说就是新浪微博营销这块的,提供基于新浪微博的各项服务. 同时也在寻找对网络(微博)营销的才子一起合作创业,感兴趣请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwPwrp.html" rel="bookmark" class="title">基于ibeacon的学生课堂签到app</a>
					<div>
						问题描述 基于ibeacon的学生课堂签到app 毕业设计做一个学生课堂考勤app,因扫描二维码的签到方式缺乏准确定位能力,所以使用ibeacon,本想使用微信摇一摇的方式来搜基站消息推送进行签到,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwx8vvb.html" rel="bookmark" class="title">Windows Server 2016 配置指南 之 安装 APCu 拓展</a>
					<div>
						APCu 前身是 APC,一个免费开源且应用很广的字节码和对象缓存软件.目前 Godaddy.Mediatemple 等网站依旧有广泛运用的 APC或APCu.目前 Zend OPcache 依旧是  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE212z.html" rel="bookmark" class="title">Simple Rtmp Server的安装与简单使用</a>
					<div>
						Simple Rtmp Server是一个国人编写的开源的RTMP/HLS流媒体服务器. 功能与nginx-rtmp-module类似, 可以实现rtmp/hls的分发.   有关nginx-rtmp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZE8gop.html" rel="bookmark" class="title">直播播流不成功如何排查</a>
					<div>
						1. 排查对应的域名是否进行直播加速配置 要进行直播推流,用户必须得开启直播加速-&gt;配置直播域名-&gt;直播推流,可以参考[快速开始]: 2. 排查推流是否成功 在直播控制台-流管理-选择对应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQ3W8p.html" rel="bookmark" class="title">浅谈seo能给我们带来什么？</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 唯一一个可以算的上百度对手的一家搜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZWkaz.html" rel="bookmark" class="title">js文件-angular 怎么同时用controller，directive，filter</a>
					<div>
						问题描述 angular 怎么同时用controller,directive,filter 我再页面中引用了3个js文件,一个是controller,一个是directive,一个是filter,发现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm7B5b.html" rel="bookmark" class="title">《编写高质量Python代码的59个有效方法》&mdash;&mdash;第10条：尽量用enumerate取代range</a>
					<div>
						第10条:尽量用enumerate取代range 在一系列整数上面迭代时,内置的range函数很有用. 对于字符串列表这样的序列式数据结构,可以直接在上面迭代. 当迭代列表的时候,通常还想知道当前元素 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXq95Kz.html" rel="bookmark" class="title">第6周 聚集索引</a>
					<div>
						原文:第6周 聚集索引 上个星期我向你介绍了堆表(heap tables).我们说过,在SQL Server表可以是堆表(Heap Table)或者聚集表(Clustered Table)--一个在它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBRW8b.html" rel="bookmark" class="title">jar-java&period;lang&period;NoClassDefFoundError</a>
					<div>
						问题描述 java.lang.NoClassDefFoundError java.lang.NoClassDefFoundError: com.qiniu.android.storage.Upload ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQERmp.html" rel="bookmark" class="title">CSDN泄密引贼 北京海淀警方逮捕4人</a>
					<div>
						本报讯(记者 高健 通讯员 田冬冬)去年12月,CSDN(中国软件开发联盟)网站外泄600余万用户数据.这个&quot; 失误&quot;被陈某等人抓住,他们比对遭泄密http://www.aliyu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAj7jb.html" rel="bookmark" class="title">json-关于dwz删除刷新的问题</a>
					<div>
						问题描述 关于dwz删除刷新的问题 Map map=new HashMap(); map.put(&quot;statusCode&quot;, &quot;200&quot;); map.put(& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwnAdM.html" rel="bookmark" class="title">vb2005 web页面继承</a>
					<div>
						问题描述 想做一个页面的基类只有一个unload事件请问怎么做?我现在的做法是在App_code下建立一个basepage的类该类会继承自system.web.ui.page里面有一个page_unl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/p5Ryomz.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MTQxNjMxMjU4Mjg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YjNWNVlXNW5YM0JsYm1jPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/p5Ryomz.html" rel="bookmark" class="title">一次因为文件名开头包含空格而导致FTP文件一直无法下载的悲剧！</a>
					<div>
						最近负责公司研究新的多渠道打包方案,之前的打包方案太慢了,因此采用了美团的Android Signature V2 Scheme签名下的新一代渠道包打包神器 方案进行了多渠道打包.但是由于马虎,在配置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgxY5M.html" rel="bookmark" class="title">new-link中调用cocat为什么要这样写？</a>
					<div>
						问题描述 link中调用cocat为什么要这样写? Console.WriteLine(new string(&quot;aaa&quot;.AsEnumerable&lt;char&gt;().Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xo3db.html" rel="bookmark" class="title">拦截器没有起作用 帮我看下是什么问题</a>
					<div>
						问题描述 小弟初学拦截器 现做了个登录拦截器 没起作用 帮我看下 少什么东西struts.xml&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22onVb.html" rel="bookmark" class="title">从用户社区、机票、酒店类切入旅游市场机会越来越小</a>
					<div>
						随着从用户社区.机票.酒店类切入旅游市场机会越来越小,目的地市场资源的整合成了在线旅游角逐的新大陆:另一方面讲,ADS( 指定旅游目的地协议)框架的宽松化也为出境自助游释放了更多的空间.&quot;乐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOjnwb.html" rel="bookmark" class="title">超模刘雯回归BurberryT台 微博表示激动不已</a>
					<div>
						刘雯再次回归Burberry秀场T台 伦敦时间9月17日Burberry秀场http://www.aliyun.com/zixun/aggregation/549.html&quot;&gt;发布会. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GvEOp.html" rel="bookmark" class="title">原生js配合cookie制作保存路径的拖拽&lowbar;javascript技巧</a>
					<div>
						主要是运用了原生js封装了一个cookie,然后使用了三个事件做拖拽,分别是onmousedown,onmousemove,onmouseup,这三个事件其中两个需要添加事件对象,也就是event,事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlymAp.html" rel="bookmark" class="title">VBS教程：VBScript 语句-Public 语句&lowbar;vbs</a>
					<div>
						Public 语句 定义公有变量并分配存储空间.在 Class 块中定义私有变量. Public varname[([subscripts])][, varname[([subscripts])]]  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
